package Security::devs;

use Security::find;
use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw(&init() &print());

our (%devs);

sub init {
	print ( STDERR  "In Security::devs::init()\n") if ( $main::opts{'d'} );

	&main::read_config('ignoredevdir');
	&Security::find::add_wanted (\&devs_wanted);
}

# Check to see any character or block special devices not in /dev.  Again 
# from HP-UX System Security manual
sub devs_wanted {
	if  ( ! -l $File::Find::name && 
		( -b $File::Find::name || -c $File::Find::name )) {
		my ($res) = 1;
		for (my ($i)= 0; $i <= $#main::ignoredevdir; $i++) {
			$res = 0 if ( $File::Find::name =~ /^$main::ignoredevdir[$i]/ );
		}
		$devs{$File::Find::name} = 1 if ($res);
	}
}

sub print {
	print ( STDERR  "In Security::devs::print()\n") if ( $main::opts{'d'} );

	&main::print_data ("\n\nchecking for block & character special devices not in /dev:\n", %devs);
}

1;
