package Security::exports;

use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() &check() &print() );

our (%exports);

sub init {
	print ( STDERR  "In Security::exports::init()\n") if ( $main::opts{'d'} );

	printf STDERR "Need to define \$showmount in Security::$^O.pm\n"
		if ( ! defined $main::showmount );
}

# Check to see what hosts have filesystems exported R/W to the world.  This 
# idea comes from the HP-UX System Security manual
sub check {
	local *FP;
	my ($dir, $dummy, @matches, @lines, $rofound);

	print ( STDERR "In Security::exports::check()\n") if ( $main::opts{'d'} );
	if ( -f $main::showmount ) {
		open(FP, "$main::showmount -e localhost 2>/dev/null |") || die "Could not run $main::showmount\n";
		while (<FP>) {
			chop;
			$dummy = $_;
			$dummy =~ s/^.* //o;
			$dir = $_;
			$dir =~ s/ .*$//o;

			# Now double check to see if the filesystem is RO or RW
			if ($dummy =~ /\(everyone\)/o) {

				# If we have not read in the exports file, do so.
				if ( -f $main::exportsfile && ! scalar @lines) {
					open(FP2, "$main::exportsfile") || die "Could not open exports file $main::exportsfile\n";
					@lines = <FP2>;
					close FP2;
				}

				if ( scalar @lines ) {
					$rofound = 0;
					@matches = grep (/$dir\b/, @lines);
					grep (/\bro\b/ && ($rofound=1), @matches);
					$exports{$dir} = 1 if ( ! $rofound );
				} else {
					$exports{$dir} = 1;
				}
			}
		}
		close FP;
	}
}

sub print {
	print ( STDERR  "In Security::exports::print()\n") if ( $main::opts{'d'} );

	&main::print_data ("\n\nchecking for world exported filesystems:\n", %exports);
}

1;
