package Security::fs;

use Security::find;
use Sys::Filesystem;
use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() );

sub init {
	print ( STDERR  "In Security::fs::init()\n") if ( $main::opts{'d'} );

	&main::read_config('ignorefs');

	# No longer need to register a wanted subroutine, since we are just
	# going to add the filesystems of our excluded types to the ignoredir
	# configuration option (see Security::find.pm).

	# if ignoredir is not defined, assume we have not yet called
	# Security::find::init(), and fail, otherwise it will overwrite
	# our adding directories to ignoredir
	if ( ! defined @main::ignoredir ) {
		print STDERR "Security::fs::init() called before Security::find::init()\nPlease fix module load ordering\n";
		return
	}

	my $fs = new Sys::Filesystem;
	my @filesystems = $fs->filesystems();
	for (@filesystems) {
		for (my ($i) = 0; $i <= $#main::ignorefs; $i++) {
			if ( $fs->format($_) eq $main::ignorefs[$i] ) {
				push (@main::ignoredir, $_);
				printf STDERR "\tAdding $_ to ignoredir because it is of fstyp ($main::ignorefs[$i])\n" 
					if ( $main::opts{'d'} );
			}
		}
	}
}

1;
